#include <windows.h>
#include "MapLine.h"

CMapLine::CMapLine (CMapLine* lpLine)
{
	*this = *lpLine;
}

CMapLine::CMapLine (LPMAPLINE1 lpLine1)
{
	CopyMemory(&m_vFrom,&lpLine1->vFrom,sizeof(VERTEX));
	CopyMemory(&m_vTo,&lpLine1->vTo,sizeof(VERTEX));
	m_Flags = lpLine1->Flags;
	m_Types = lpLine1->Types;
	m_Tag = lpLine1->Tag;
	CopyMemory(&m_sRight,&lpLine1->sRight,sizeof(SIDEDEF));
	CopyMemory(&m_sLeft,&lpLine1->sLeft,sizeof(SIDEDEF));
	m_Special = 0;
	ZeroMemory(m_Args,sizeof(m_Args));
}

CMapLine::CMapLine (LPMAPLINE2 lpLine2)
{
	CopyMemory(&m_vFrom,&lpLine2->vFrom,sizeof(VERTEX));
	CopyMemory(&m_vTo,&lpLine2->vTo,sizeof(VERTEX));
	m_Flags = lpLine2->Flags;
	m_Types = 0;
	m_Tag = 0;
	CopyMemory(&m_sRight,&lpLine2->sRight,sizeof(SIDEDEF));
	CopyMemory(&m_sLeft,&lpLine2->sLeft,sizeof(SIDEDEF));
	m_Special = lpLine2->Special;
	CopyMemory(m_Args,lpLine2->Args,sizeof(m_Args));
}

CMapLine::CMapLine ()
{
	Reset();
}

CMapLine::~CMapLine ()
{
}

VOID CMapLine::Reset (VOID)
{
	ZeroMemory(&m_vFrom,sizeof(VERTEX));
	ZeroMemory(&m_vTo,sizeof(VERTEX));
	m_Flags = 0;
	m_Types = 0;
	m_Tag = 0;
	ZeroMemory(&m_sRight,sizeof(SIDEDEF));
	ZeroMemory(&m_sLeft,sizeof(SIDEDEF));
	m_Special = 0;
	ZeroMemory(m_Args,sizeof(m_Args));
}

VOID CMapLine::operator= (CMapLine& Line)
{
	CopyMemory(&m_vFrom,&Line.m_vFrom,sizeof(VERTEX));
	CopyMemory(&m_vTo,&Line.m_vTo,sizeof(VERTEX));
	m_Flags = Line.m_Flags;
	m_Types = Line.m_Types;
	m_Tag = Line.m_Tag;
	CopyMemory(&m_sRight,&Line.m_sRight,sizeof(SIDEDEF));
	CopyMemory(&m_sLeft,&Line.m_sLeft,sizeof(SIDEDEF));
	m_Special = Line.m_Special;
	CopyMemory(m_Args,Line.m_Args,sizeof(m_Args));
}

LPMAPLINE1 CMapLine::GetMapLine1 (LPMAPLINE1 lpLine1)
{
	CopyMemory(&lpLine1->vFrom,&m_vFrom,sizeof(VERTEX));
	CopyMemory(&lpLine1->vTo,&m_vTo,sizeof(VERTEX));
	lpLine1->Flags = m_Flags;
	lpLine1->Types = m_Types;
	lpLine1->Tag = m_Tag;
	CopyMemory(&lpLine1->sRight,&m_sRight,sizeof(SIDEDEF));
	CopyMemory(&lpLine1->sLeft,&m_sLeft,sizeof(SIDEDEF));
	return lpLine1;
}

LPMAPLINE2 CMapLine::GetMapLine2 (LPMAPLINE2 lpLine2)
{
	CopyMemory(&lpLine2->vFrom,&m_vFrom,sizeof(VERTEX));
	CopyMemory(&lpLine2->vTo,&m_vTo,sizeof(VERTEX));
	lpLine2->Flags = m_Flags;
	CopyMemory(&lpLine2->sRight,&m_sRight,sizeof(SIDEDEF));
	CopyMemory(&lpLine2->sLeft,&m_sLeft,sizeof(SIDEDEF));
	lpLine2->Special = m_Special;
	CopyMemory(lpLine2->Args,m_Args,sizeof(m_Args));
	return lpLine2;
}