#include <windows.h>
#include "MapLinedef.h"

CMapLinedef::CMapLinedef (CMapLinedef* lpLinedef)
{
	*this = *lpLinedef;
}

CMapLinedef::CMapLinedef (LPLINEDEF1 lpLinedef1)
{
	m_vFrom = lpLinedef1->vFrom;
	m_vTo = lpLinedef1->vTo;
	m_Flags = lpLinedef1->Flags;
	m_Types = lpLinedef1->Types;
	m_Tag = lpLinedef1->Tag;
	m_sRight = lpLinedef1->sRight;
	m_sLeft = lpLinedef1->sLeft;
	m_Special = 0;
	ZeroMemory(m_Args,sizeof(m_Args));
}

CMapLinedef::CMapLinedef (LPLINEDEF2 lpLinedef2)
{
	m_vFrom = lpLinedef2->vFrom;
	m_vTo = lpLinedef2->vTo;
	m_Flags = lpLinedef2->Flags;
	m_sRight = lpLinedef2->sRight;
	m_sLeft = lpLinedef2->sLeft;
	m_Special = lpLinedef2->Special;
	CopyMemory(m_Args,lpLinedef2->Args,sizeof(m_Args));
}

CMapLinedef::CMapLinedef ()
{
	Reset();
}

CMapLinedef::~CMapLinedef ()
{
}

VOID CMapLinedef::Reset (VOID)
{
	m_vFrom = 0;
	m_vTo = 0;
	m_Flags = 0;
	m_Types = 0;
	m_Tag = 0;
	m_sRight = 0;
	m_sLeft = 0;
	m_Special = 0;
	ZeroMemory(m_Args,sizeof(m_Args));
}

VOID CMapLinedef::operator= (CMapLinedef& Linedef)
{
	m_vFrom = Linedef.m_vFrom;
	m_vTo = Linedef.m_vTo;
	m_Flags = Linedef.m_Flags;
	m_Types = Linedef.m_Types;
	m_Tag = Linedef.m_Tag;
	m_sRight = Linedef.m_sRight;
	m_sLeft = Linedef.m_sLeft;
	m_Special = Linedef.m_Special;
	CopyMemory(m_Args,Linedef.m_Args,sizeof(m_Args));
}

LPLINEDEF1 CMapLinedef::GetMapLinedef1 (LPLINEDEF1 lpLinedef1)
{
	lpLinedef1->vFrom = m_vFrom;
	lpLinedef1->vTo = m_vTo;
	lpLinedef1->Flags = m_Flags;
	lpLinedef1->Types = m_Types;
	lpLinedef1->Tag = m_Tag;
	lpLinedef1->sRight = m_sRight;
	lpLinedef1->sLeft = m_sLeft;
	return lpLinedef1;
}

LPLINEDEF2 CMapLinedef::GetMapLinedef2 (LPLINEDEF2 lpLinedef2)
{
	lpLinedef2->vFrom = m_vFrom;
	lpLinedef2->vTo = m_vTo;
	lpLinedef2->Flags = m_Flags;
	lpLinedef2->sRight = m_sRight;
	lpLinedef2->sLeft = m_sLeft;
	lpLinedef2->Special = m_Special;
	CopyMemory(lpLinedef2->Args,m_Args,sizeof(m_Args));
	return lpLinedef2;
}