#include <math.h>
#include <windows.h>
#include "MapConvert.h"
#include "MapThing.h"
#include "MapLine.h"
#include "Prefabs.h"

INT CPrefabs::m_iLightLevel = 160;
CHAR CPrefabs::m_szCeiling[16] = "FLAT19";
CHAR CPrefabs::m_szFloor[16] = "FLOOR7_1";
BOOL CPrefabs::m_bUpperPanels = TRUE;

VERTEX CPrefabs::m_vSquare[] =
{
	{1, 1},
	{-1, 1},
	{-1, -1},
	{1, -1}
};

VERTEX CPrefabs::m_vOuter[] =
{
	{-22, 22},
	{-28, 8},
	{-28, -8},
	{-22, -22},
	{-8, -28},
	{8, -28},
	{22, -22},
	{28, -8},
	{28, 8},
	{22, 22},
	{8, 28},
	{-8, 28}
};

VERTEX CPrefabs::m_vMiddle[] =
{
	{-20, 8},
	{-20, -8},
	{-8, -20},
	{8, -20},
	{20, -8},
	{20, 8},
	{8, 20},
	{-8, 20}
};

MONSTER_CONVERSION CPrefabs::m_MonsterTable[] =
{
	{0x6d, 3004, 1, 90, FALSE},
	{0x6c, 3004, 1, 0, FALSE},
	{0x6f, 3004, 1, 270, FALSE},
	{0x6e, 3004, 1, 180, FALSE},
	{0x71, 3004, 1, 90, TRUE},
	{0x70, 3004, 1, 0, TRUE},
	{0x73, 3004, 1, 270, TRUE},
	{0x72, 3004, 1, 180, TRUE},
	{0x75,    9, 1, 90, FALSE},
	{0x74,    9, 1, 0, FALSE},
	{0x77,    9, 1, 270, FALSE},
	{0x76,    9, 1, 180, FALSE},
	{0x79,    9, 1, 90, TRUE},
	{0x78,    9, 1, 0, TRUE},
	{0x7b,    9, 1, 270, TRUE},
	{0x7a,    9, 1, 180, TRUE},
	{0x7f,   84, 1,  90, FALSE},
	{0x7e,   84, 1,   0, FALSE},
	{0x81,   84, 1, 270, FALSE},
	{0x80,   84, 1, 180, FALSE},
	{0x83,   84, 1,  90, TRUE},
	{0x82,   84, 1,   0, TRUE},
	{0x85,   84, 1, 270, TRUE},
	{0x84,   84, 1, 180, TRUE},
	{0x8b, 3002, 1,  90, TRUE},
	{0x8a, 3002, 1,   0, TRUE},
	{0x8d, 3002, 1, 270, TRUE},
	{0x8c, 3002, 1, 180, TRUE},
	{0xd9, 3001, 1,  90, FALSE},
	{0xd8, 3001, 1,   0, FALSE},
	{0xdb, 3001, 1, 270, FALSE},
	{0xda, 3001, 1, 180, FALSE},
	{0xdd, 3001, 1,  90, TRUE},
	{0xdc, 3001, 1,   0, TRUE},
	{0xdf, 3001, 1, 270, TRUE},
	{0xde, 3001, 1, 180, TRUE},
	{0x91, 3004, 3,  90, FALSE},
	{0x90, 3004, 3,   0, FALSE},
	{0x93, 3004, 3, 270, FALSE},
	{0x92, 3004, 3, 180, FALSE},
	{0x95, 3004, 3,  90, TRUE},
	{0x94, 3004, 3,   0, TRUE},
	{0x97, 3004, 3, 270, TRUE},
	{0x96, 3004, 3, 180, TRUE},
	{0x99,    9, 3,  90, FALSE},
	{0x98,    9, 3,   0, FALSE},
	{0x9b,    9, 3, 270, FALSE},
	{0x9a,    9, 3, 180, FALSE},
	{0x9d,    9, 3,  90, TRUE},
	{0x9c,    9, 3,   0, TRUE},
	{0x9f,    9, 3, 270, TRUE},
	{0x9e,    9, 3, 180, TRUE},
	{0xa3,   84, 3,  90, FALSE},
	{0xa2,   84, 3,   0, FALSE},
	{0xa5,   84, 3, 270, FALSE},
	{0xa4,   84, 3, 180, FALSE},
	{0xa7,   84, 3,  90, TRUE},
	{0xa6,   84, 3,   0, TRUE},
	{0xa9,   84, 3, 270, TRUE},
	{0xa8,   84, 3, 180, TRUE},
	{0xaf, 3002, 3,  90, TRUE},
	{0xae, 3002, 3,   0, TRUE},
	{0xb1, 3002, 3, 270, TRUE},
	{0xb0, 3002, 3, 180, TRUE},
	{0xeb, 3001, 3,  90, FALSE},
	{0xea, 3001, 3,   0, FALSE},
	{0xed, 3001, 3, 270, FALSE},
	{0xec, 3001, 3, 180, FALSE},
	{0xef, 3001, 3,  90, TRUE},
	{0xee, 3001, 3,   0, TRUE},
	{0xf1, 3001, 3, 270, TRUE},
	{0xf0, 3001, 3, 180, TRUE},
	{0xb5, 3004, 4,  90, FALSE},
	{0xb4, 3004, 4,   0, FALSE},
	{0xb7, 3004, 4, 270, FALSE},
	{0xb6, 3004, 4, 180, FALSE},
	{0xb9, 3004, 4,  90, TRUE},
	{0xb8, 3004, 4,   0, TRUE},
	{0xba, 3004, 4, 270, TRUE},
	{0xbb, 3004, 4, 180, TRUE},
	{0xbd,    9, 4,  90, FALSE},
	{0xbc,    9, 4,   0, FALSE},
	{0xbf,    9, 4, 270, FALSE},
	{0xbe,    9, 4, 180, FALSE},
	{0xc1,    9, 4,  90, TRUE},
	{0xc0,    9, 4,   0, TRUE},
	{0xc3,    9, 4, 270, TRUE},
	{0xc2,    9, 4, 180, TRUE},
	{0xc7,   84, 4,  90, FALSE},
	{0xc6,   84, 4,   0, FALSE},
	{0xc9,   84, 4, 270, FALSE},
	{0xc8,   84, 4, 180, FALSE},
	{0xcb,   84, 4,  90, TRUE},
	{0xca,   84, 4,   0, TRUE},
	{0xcd,   84, 4, 270, TRUE},
	{0xcc,   84, 4, 180, TRUE},
	{0xd3, 3002, 4,  90, TRUE},
	{0xd2, 3002, 4,   0, TRUE},
	{0xd5, 3002, 4, 270, TRUE},
	{0xd4, 3002, 4, 180, TRUE},
	{0xfd, 3001, 4,  90, FALSE},
	{0xfc, 3001, 4,   0, FALSE},
	{0xff, 3001, 4, 270, FALSE},
	{0xfe, 3001, 4, 180, FALSE},
	{0x101,3001, 4,  90, TRUE},
	{0x100,3001, 4,   0, TRUE},
	{0x103,3001, 4, 270, TRUE},
	{0x102,3001, 4, 180, TRUE},
	{0, 0, 0, 0, 0}
};

//TJL - For TC
MONSTER_CONVERSION CPrefabs::m_MonsterTableTC[] =
{
	{0x6d, 20002, 1, 90, FALSE},
	{0x6c, 20002, 1, 0, FALSE},
	{0x6f, 20002, 1, 270, FALSE},
	{0x6e, 20002, 1, 180, FALSE},
	{0x71, 20202, 1, 90, TRUE},
	{0x70, 20202, 1, 0, TRUE},
	{0x73, 20202, 1, 270, TRUE},
	{0x72, 20202, 1, 180, TRUE},
	{0x75, 20004, 1, 90, FALSE},
	{0x74, 20004, 1, 0, FALSE},
	{0x77, 20004, 1, 270, FALSE},
	{0x76, 20004, 1, 180, FALSE},
	{0x79, 20204, 1, 90, TRUE},
	{0x78, 20204, 1, 0, TRUE},
	{0x7b, 20204, 1, 270, TRUE},
	{0x7a, 20204, 1, 180, TRUE},
	{0x7f, 20003, 1,  90, FALSE},
	{0x7e, 20003, 1,   0, FALSE},
	{0x81, 20003, 1, 270, FALSE},
	{0x80, 20003, 1, 180, FALSE},
	{0x83, 20203, 1,  90, TRUE},
	{0x82, 20203, 1,   0, TRUE},
	{0x85, 20203, 1, 270, TRUE},
	{0x84, 20203, 1, 180, TRUE},
	{0x8b, 20201, 1,  90, TRUE},
	{0x8a, 20201, 1,   0, TRUE},
	{0x8d, 20201, 1, 270, TRUE},
	{0x8c, 20201, 1, 180, TRUE},
	{0xd9, 20005, 1,  90, FALSE},
	{0xd8, 20005, 1,   0, FALSE},
	{0xdb, 20005, 1, 270, FALSE},
	{0xda, 20005, 1, 180, FALSE},
	{0xdd, 20205, 1,  90, TRUE},
	{0xdc, 20205, 1,   0, TRUE},
	{0xdf, 20205, 1, 270, TRUE},
	{0xde, 20205, 1, 180, TRUE},
	{0x91, 20002, 3,  90, FALSE},
	{0x90, 20002, 3,   0, FALSE},
	{0x93, 20002, 3, 270, FALSE},
	{0x92, 20002, 3, 180, FALSE},
	{0x95, 20202, 3,  90, TRUE},
	{0x94, 20202, 3,   0, TRUE},
	{0x97, 20202, 3, 270, TRUE},
	{0x96, 20202, 3, 180, TRUE},
	{0x99, 20004, 3,  90, FALSE},
	{0x98, 20004, 3,   0, FALSE},
	{0x9b, 20004, 3, 270, FALSE},
	{0x9a, 20004, 3, 180, FALSE},
	{0x9d, 20204, 3,  90, TRUE},
	{0x9c, 20204, 3,   0, TRUE},
	{0x9f, 20204, 3, 270, TRUE},
	{0x9e, 20204, 3, 180, TRUE},
	{0xa3, 20003, 3,  90, FALSE},
	{0xa2, 20003, 3,   0, FALSE},
	{0xa5, 20003, 3, 270, FALSE},
	{0xa4, 20003, 3, 180, FALSE},
	{0xa7, 20203, 3,  90, TRUE},
	{0xa6, 20203, 3,   0, TRUE},
	{0xa9, 20203, 3, 270, TRUE},
	{0xa8, 20203, 3, 180, TRUE},
	{0xaf, 20201, 3,  90, TRUE},
	{0xae, 20201, 3,   0, TRUE},
	{0xb1, 20201, 3, 270, TRUE},
	{0xb0, 20201, 3, 180, TRUE},
	{0xeb, 20005, 3,  90, FALSE},
	{0xea, 20005, 3,   0, FALSE},
	{0xed, 20005, 3, 270, FALSE},
	{0xec, 20005, 3, 180, FALSE},
	{0xef, 20205, 3,  90, TRUE},
	{0xee, 20205, 3,   0, TRUE},
	{0xf1, 20205, 3, 270, TRUE},
	{0xf0, 20205, 3, 180, TRUE},
	{0xb5, 20002, 4,  90, FALSE},
	{0xb4, 20002, 4,   0, FALSE},
	{0xb7, 20002, 4, 270, FALSE},
	{0xb6, 20002, 4, 180, FALSE},
	{0xb9, 20202, 4,  90, TRUE},
	{0xb8, 20202, 4,   0, TRUE},
	{0xba, 20202, 4, 270, TRUE},
	{0xbb, 20202, 4, 180, TRUE},
	{0xbd, 20004, 4,  90, FALSE},
	{0xbc, 20004, 4,   0, FALSE},
	{0xbf, 20004, 4, 270, FALSE},
	{0xbe, 20004, 4, 180, FALSE},
	{0xc1, 20204, 4,  90, TRUE},
	{0xc0, 20204, 4,   0, TRUE},
	{0xc3, 20204, 4, 270, TRUE},
	{0xc2, 20204, 4, 180, TRUE},
	{0xc7, 20003, 4,  90, FALSE},
	{0xc6, 20003, 4,   0, FALSE},
	{0xc9, 20003, 4, 270, FALSE},
	{0xc8, 20003, 4, 180, FALSE},
	{0xcb, 20203, 4,  90, TRUE},
	{0xca, 20203, 4,   0, TRUE},
	{0xcd, 20203, 4, 270, TRUE},
	{0xcc, 20203, 4, 180, TRUE},
	{0xd3, 20201, 4,  90, TRUE},
	{0xd2, 20201, 4,   0, TRUE},
	{0xd5, 20201, 4, 270, TRUE},
	{0xd4, 20201, 4, 180, TRUE},
	{0xfd, 20005, 4,  90, FALSE},
	{0xfc, 20005, 4,   0, FALSE},
	{0xff, 20005, 4, 270, FALSE},
	{0xfe, 20005, 4, 180, FALSE},
	{0x101,20205, 4,  90, TRUE},
	{0x100,20205, 4,   0, TRUE},
	{0x103,20205, 4, 270, TRUE},
	{0x102,20205, 4, 180, TRUE},
	//Additional for Blake Stone
	{0x67, 0, 1, 0, TRUE}, 
	{0x68, 0, 3, 0, TRUE}, 
	{0x69, 0, 4, 0, TRUE}, 
	{0x6A, 0, 1, 0, TRUE}, 
	{0x6B, 0, 3, 0, TRUE}, 
	{0x7D, 0, 4, 0, TRUE}, 
	{0x81, 20003, 1, 270, FALSE}, 
	{0x86, 0, 1, 0, TRUE}, 
	{0x87, 0, 3, 0, TRUE}, 
	{0x88, 0, 4, 0, TRUE}, 
	{0x89, 0, 1, 0, TRUE}, 
	{0x8E, 20010, 3, 0, TRUE}, 
	{0x8F, 20010, 4, 0, TRUE}, 
	{0xA1, 0, 4, 0, TRUE}, 
	{0xAA, 0, 1, 0, TRUE}, 
	{0xAB, 0, 3, 0, TRUE}, 
	{0xAC, 0, 4, 0, TRUE}, 
	{0xAD, 0, 3, 0, TRUE}, 
	{0xCE, 0, 1, 0, TRUE}, 
	{0xCF, 0, 3, 0, TRUE}, 
	{0xD0, 0, 4, 0, TRUE}, 
	{0xD6, 20010, 1, 0, TRUE}, 
	{0xE0, 0, 1, 0, FALSE}, 
	{0xE1, 0, 1, 90, FALSE}, 
	{0xE2, 0, 1, 180, FALSE}, 
	{0xE3, 0, 1, 270, FALSE}, 
	{0xE4, 0, 1, 0, TRUE}, 
	{0xE5, 0, 1, 0, TRUE}, 
	{0xE6, 0, 1, 0, TRUE}, 
	{0xE7, 0, 1, 0, TRUE}, 
	{0xF2, 0, 3, 0, FALSE}, 
	{0xF3, 0, 3, 90, FALSE}, 
	{0xF4, 0, 3, 180, FALSE}, 
	{0xF5, 0, 3, 270, FALSE}, 
	{0xF6, 0, 3, 0, TRUE}, 
	{0xF7, 0, 3, 0, TRUE}, 
	{0xF8, 0, 3, 0, TRUE}, 
	{0xF9, 0, 3, 0, TRUE}, 
	{0x104, 0, 1, 0, TRUE}, 
	{0x105, 0, 1, 90, TRUE}, 
	{0x106, 0, 1, 180, TRUE}, 
	{0x107, 0, 1, 270, TRUE}, 
	{0x108, 0, 1, 0, TRUE}, 
	{0x109, 0, 1, 90, TRUE}, 
	{0x10A, 0, 1, 180, TRUE}, 
	{0x10B, 0, 1, 270, TRUE}, 
	{0x10E, 0, 4, 0, TRUE}, 
	{0x10F, 0, 3, 0, TRUE}, 
	{0x110, 0, 1, 0, TRUE}, 
	{0x111, 0, 1, 0, TRUE}, 
	{0x112, 0, 3, 0, TRUE}, 
	{0x113, 0, 4, 0, TRUE}, 
	{0x114, 0, 3, 0, TRUE}, 
	{0x116, 0, 3, 0, TRUE}, 
	{0x117, 0, 3, 90, TRUE}, 
	{0x118, 0, 3, 180, TRUE}, 
	{0x119, 0, 3, 270, TRUE}, 
	{0x11A, 0, 3, 0, TRUE}, 
	{0x11B, 0, 3, 90, TRUE}, 
	{0x11C, 0, 3, 180, TRUE}, 
	{0x11D, 0, 3, 270, TRUE}, 
	{0x120, 0, 4, 0, TRUE}, 
	{0x121, 0, 3, 0, TRUE}, 
	{0x122, 0, 1, 0, TRUE}, 
	{0x123, 0, 1, 0, TRUE}, 
	{0x124, 0, 3, 0, TRUE}, 
	{0x125, 0, 4, 0, TRUE}, 
	{0x126, 0, 4, 0, TRUE}, 
	{0x128, 0, 4, 0, TRUE}, 
	{0x129, 0, 4, 90, TRUE}, 
	{0x12A, 0, 4, 180, TRUE}, 
	{0x12B, 0, 4, 270, TRUE}, 
	{0x12C, 0, 4, 0, TRUE}, 
	{0x12D, 0, 4, 90, TRUE}, 
	{0x12E, 0, 4, 180, TRUE}, 
	{0x12F, 0, 4, 270, TRUE}, 
	{0x132, 0, 1, 0, TRUE}, 
	{0x133, 0, 1, 0, TRUE}, 
	{0x134, 0, 3, 0, TRUE}, 
	{0x135, 0, 4, 0, TRUE}, 
	{0x136, 0, 1, 0, TRUE}, 
	{0x137, 0, 3, 0, TRUE}, 
	{0x138, 0, 4, 0, TRUE}, 
	{0x13A, 0, 1, 0, FALSE}, 
	{0x13B, 0, 1, 90, FALSE}, 
	{0x13C, 0, 1, 180, FALSE}, 
	{0x13D, 0, 1, 270, FALSE}, 
	{0x13E, 0, 1, 0, TRUE}, 
	{0x13F, 0, 1, 90, TRUE}, 
	{0x140, 0, 1, 180, TRUE}, 
	{0x141, 0, 1, 270, TRUE}, 
	{0x144, 0, 1, 0, TRUE}, 
	{0x145, 0, 1, 0, TRUE}, 
	{0x146, 0, 1, 0, TRUE}, 
	{0x148, 0, 1, 0, FALSE}, 
	{0x149, 0, 1, 90, FALSE}, 
	{0x14A, 0, 1, 180, FALSE}, 
	{0x14B, 0, 1, 270, FALSE}, 
	{0x14C, 0, 3, 0, FALSE}, 
	{0x14D, 0, 3, 90, FALSE}, 
	{0x14E, 0, 3, 180, FALSE}, 
	{0x14F, 0, 3, 270, FALSE}, 
	{0x150, 0, 3, 0, TRUE}, 
	{0x151, 0, 3, 90, TRUE}, 
	{0x152, 0, 3, 180, TRUE}, 
	{0x153, 0, 3, 270, TRUE}, 
	{0x156, 0, 3, 0, TRUE}, 
	{0x157, 0, 3, 0, TRUE}, 
	{0x158, 0, 3, 0, TRUE}, 
	{0x15A, 0, 3, 180, FALSE}, 
	{0x15B, 0, 3, 270, FALSE}, 
	{0x15C, 0, 3, 0, FALSE}, 
	{0x15D, 0, 3, 90, FALSE}, 
	{0x15E, 0, 4, 0, FALSE}, 
	{0x15F, 0, 4, 90, FALSE}, 
	{0x160, 0, 4, 180, FALSE}, 
	{0x161, 0, 4, 270, FALSE}, 
	{0x162, 0, 4, 0, TRUE}, 
	{0x163, 0, 4, 90, TRUE}, 
	{0x164, 0, 4, 180, TRUE}, 
	{0x165, 0, 4, 270, TRUE}, 
	{0x168, 0, 4, 0, TRUE}, 
	{0x169, 0, 4, 0, TRUE}, 
	{0x16A, 0, 4, 0, TRUE}, 
	{0x16C, 0, 4, 0, FALSE}, 
	{0x16D, 0, 4, 90, FALSE}, 
	{0x16E, 0, 4, 180, FALSE}, 
	{0x16F, 0, 4, 270, FALSE}, 
	{0x170, 0, 4, 0, FALSE}, 
	{0x171, 0, 4, 90, FALSE}, 
	{0x172, 0, 4, 180, FALSE}, 
	{0x173, 0, 4, 270, FALSE}, 
	{0x174, 0, 4, 0, TRUE}, 
	{0x175, 0, 4, 0, TRUE}, 
	{0x176, 0, 4, 0, TRUE}, 
	{0x177, 0, 4, 0, TRUE}, 
	{0x1F8, 20205, 1, 0, TRUE}, 
	{0x1F9, 20205, 1, 90, TRUE}, 
	{0x1FA, 20205, 1, 180, TRUE}, 
	{0x1FB, 20205, 1, 270, TRUE}, 
	{0x1FC, 0, 1, 0, TRUE}, 
	{0x1FD, 0, 1, 90, TRUE}, 
	{0x1FE, 0, 1, 180, TRUE}, 
	{0x1FF, 0, 1, 270, TRUE}, 
	{0x200, 0, 1, 0, TRUE}, 
	{0x201, 0, 1, 90, TRUE}, 
	{0x202, 0, 1, 180, TRUE}, 
	{0x203, 0, 1, 270, TRUE}, 
	{0x204, 20202, 1, 0, TRUE}, 
	{0x205, 20202, 1, 90, TRUE}, 
	{0x206, 20202, 1, 180, TRUE}, 
	{0x207, 20202, 1, 270, TRUE}, 
	{0x20A, 20205, 3, 0, TRUE}, 
	{0x20B, 20205, 3, 90, TRUE}, 
	{0x20C, 20205, 3, 180, TRUE}, 
	{0x20D, 20205, 3, 270, TRUE}, 
	{0x20E, 0, 3, 0, TRUE}, 
	{0x20F, 0, 3, 90, TRUE}, 
	{0x210, 0, 3, 180, TRUE}, 
	{0x211, 0, 3, 270, TRUE}, 
	{0x212, 0, 3, 0, TRUE}, 
	{0x213, 0, 3, 90, TRUE}, 
	{0x214, 0, 3, 180, TRUE}, 
	{0x215, 0, 3, 270, TRUE}, 
	{0x216, 20202, 3, 0, TRUE}, 
	{0x217, 20202, 3, 90, TRUE}, 
	{0x218, 20202, 3, 180, TRUE}, 
	{0x219, 20202, 3, 270, TRUE}, 
	{0x21C, 20205, 4, 0, TRUE}, 
	{0x21D, 20205, 4, 90, TRUE}, 
	{0x21E, 20205, 4, 180, TRUE}, 
	{0x21F, 20205, 4, 270, TRUE}, 
	{0x220, 0, 4, 0, TRUE}, 
	{0x221, 0, 4, 90, TRUE}, 
	{0x222, 0, 4, 180, TRUE}, 
	{0x223, 0, 4, 270, TRUE}, 
	{0x224, 0, 4, 0, TRUE}, 
	{0x225, 0, 4, 90, TRUE}, 
	{0x226, 0, 4, 180, TRUE}, 
	{0x227, 0, 4, 270, TRUE}, 
	{0x228, 20202, 4, 0, TRUE}, 
	{0x229, 20202, 4, 90, TRUE}, 
	{0x22A, 20202, 4, 180, TRUE}, 
	{0x22B, 20202, 4, 270, TRUE}, 
	{0x22E, 20203, 1, 0, TRUE}, 
	{0x22F, 20203, 1, 90, TRUE}, 
	{0x230, 20203, 1, 180, TRUE}, 
	{0x231, 20203, 1, 270, TRUE}, 
	{0x240, 20203, 3, 0, TRUE}, 
	{0x241, 20203, 3, 90, TRUE}, 
	{0x242, 20203, 3, 180, TRUE}, 
	{0x243, 20203, 3, 270, TRUE}, 
	{0x252, 20203, 4, 0, TRUE}, 
	{0x253, 20203, 4, 90, TRUE}, 
	{0x254, 20203, 4, 180, TRUE}, 
	{0x255, 20203, 4, 270, TRUE}, 
	{0, 0, 0, 0, 0}
};

VOID CPrefabs::SetLightLevel (INT iLightLevel)
{
	m_iLightLevel = iLightLevel;
}

VOID CPrefabs::SetFlats (LPSTR lpszFloor, LPSTR lpszCeiling)
{
	lstrcpy(m_szFloor,lpszFloor);
	lstrcpy(m_szCeiling,lpszCeiling);
}

VOID CPrefabs::SetUpperPanels (BOOL bUpperPanels)
{
	m_bUpperPanels = bUpperPanels;
}

VOID CPrefabs::CreateColumn (CMapConvert* lpMap, INT sParent, INT x, INT y, INT iType)
{
	INT i, iSector;
	CMapLine Line[12];
	SECTOR Sector;
	CHAR szSide[8], szFloor[8], szCeiling[8];

	if(iType == 0)
	{
		lstrcpy(szSide,"STONE4");
		lstrcpy(szFloor,"FLAT5_4");
		lstrcpy(szCeiling,"FLAT5_4");
	}
	else if(iType == 1)
	{
		lstrcpy(szSide,"STONE6");
		lstrcpy(szFloor,"RROCK15");
		lstrcpy(szCeiling,"RROCK15");
	}
	else
		return;

	// Outer
	BuildLines(m_vOuter,1,Line,12,x,y);
	lstrcpy(Line[0].m_sRight.szUpper,szSide);
	lstrcpy(Line[0].m_sRight.szMiddle,"-");
	lstrcpy(Line[0].m_sRight.szLower,szSide);
	Line[0].m_sRight.Sector = sParent;
	AlignRightTexture(Line,12,64);
	iSector = lpMap->GetNewSector();
	for(i = 0; i < 12; i++)
	{
		lstrcpy(Line[i].m_sLeft.szUpper,"-");
		lstrcpy(Line[i].m_sLeft.szMiddle,"-");
		lstrcpy(Line[i].m_sLeft.szLower,"-");
		Line[i].m_sLeft.Sector = iSector;
		Line[i].m_Flags = 4;
		lpMap->AddLine(&Line[i]);
	}
	ZeroMemory(&Sector,sizeof(SECTOR));
	Sector.Floor = 8;
	Sector.Ceiling = (m_bUpperPanels) ? 72 : 56;
	Sector.Light = m_iLightLevel;
	lstrcpy(Sector.szFloor,szFloor);
	lstrcpy(Sector.szCeiling,szCeiling);
	lpMap->AddSector(&Sector);

	// Center
	for(i = 0; i < 8; i++)
		Line[i].Reset();
	BuildLines(m_vMiddle,1,Line,8,x,y);
	lstrcpy(Line[0].m_sRight.szUpper,szSide);
	lstrcpy(Line[0].m_sRight.szMiddle,"-");
	lstrcpy(Line[0].m_sRight.szLower,szSide);
	Line[0].m_sRight.Sector = iSector;
	AlignRightTexture(Line,8,64);
	iSector = lpMap->GetNewSector();
	for(i = 0; i < 8; i++)
	{
		lstrcpy(Line[i].m_sLeft.szUpper,"-");
		lstrcpy(Line[i].m_sLeft.szMiddle,"-");
		lstrcpy(Line[i].m_sLeft.szLower,"-");
		Line[i].m_sLeft.Sector = iSector;
		Line[i].m_Flags = 4;
		lpMap->AddLine(&Line[i]);
	}
	ZeroMemory(&Sector,sizeof(SECTOR));
	Sector.Floor = 16;
	Sector.Ceiling = (m_bUpperPanels) ? 64 : 48;
	Sector.Light = m_iLightLevel;
	lstrcpy(Sector.szFloor,szFloor);
	lstrcpy(Sector.szCeiling,szCeiling);
	lpMap->AddSector(&Sector);

	// Inner
	for(i = 0; i < 8; i++)
		Line[i].Reset();
	BuildLines(m_vMiddle,2,Line,8,x,y);
	lstrcpy(Line[0].m_sRight.szUpper,"-");
	lstrcpy(Line[0].m_sRight.szMiddle,szSide);
	lstrcpy(Line[0].m_sRight.szLower,"-");
	Line[0].m_sRight.Sector = iSector;
	AlignRightTexture(Line,8,64);
	for(i = 0; i < 8; i++)
	{
		Line[i].m_Flags = 1;
		lpMap->AddLine(&Line[i]);
	}
}

VOID CPrefabs::ExtendOutside (CMapConvert* lpMap, CMapLine* lpLine, INT iDir, LPSTR lpszTexture)
{
	CMapLine Line[9];
	INT x, y, i;
	SHORT iSector[3];
	SECTOR Sector[3];
	ZeroMemory(Sector,sizeof(SECTOR) * 3);
	for(i = 0; i < 9; i++)
	{
		lstrcpy(Line[i].m_sRight.szUpper,"-");
		lstrcpy(Line[i].m_sRight.szMiddle,"-");
		lstrcpy(Line[i].m_sRight.szLower,"-");
		if(i >= 6)
		{
			lstrcpy(Line[i].m_sLeft.szUpper,"-");
			lstrcpy(Line[i].m_sLeft.szMiddle,"-");
			lstrcpy(Line[i].m_sLeft.szLower,"-");
		}
	}
	switch(iDir)
	{
	case LINE_LEFT:
		x = lpLine->m_vFrom.x;
		y = lpLine->m_vFrom.y;
		for(i = 0; i < 3; i++)
		{
			Line[i].m_vFrom.y = y;
			Line[i].m_vTo.y = y;
		}
		Line[0].m_vFrom.x = x;
		Line[0].m_vTo.x = x - 48;
		Line[1].m_vFrom.x = x - 48;
		Line[1].m_vTo.x = x - 56;
		Line[2].m_vFrom.x = x - 56;
		Line[2].m_vTo.x = x - 64;
		x = lpLine->m_vTo.x;
		y = lpLine->m_vTo.y;
		for(i = 3; i < 6; i++)
		{
			Line[i].m_vFrom.y = y;
			Line[i].m_vTo.y = y;
		}
		Line[3].m_vFrom.x = x - 64;
		Line[3].m_vTo.x = x - 56;
		Line[4].m_vFrom.x = x - 56;
		Line[4].m_vTo.x = x - 48;
		Line[5].m_vFrom.x = x - 48;
		Line[5].m_vTo.x = x;
		break;
	case LINE_RIGHT:
		x = lpLine->m_vFrom.x;
		y = lpLine->m_vFrom.y;
		for(i = 0; i < 3; i++)
		{
			Line[i].m_vFrom.y = y;
			Line[i].m_vTo.y = y;
		}
		Line[0].m_vFrom.x = x;
		Line[0].m_vTo.x = x + 48;
		Line[1].m_vFrom.x = x + 48;
		Line[1].m_vTo.x = x + 56;
		Line[2].m_vFrom.x = x + 56;
		Line[2].m_vTo.x = x + 64;
		x = lpLine->m_vTo.x;
		y = lpLine->m_vTo.y;
		for(i = 3; i < 6; i++)
		{
			Line[i].m_vFrom.y = y;
			Line[i].m_vTo.y = y;
		}
		Line[3].m_vFrom.x = x + 64;
		Line[3].m_vTo.x = x + 56;
		Line[4].m_vFrom.x = x + 56;
		Line[4].m_vTo.x = x + 48;
		Line[5].m_vFrom.x = x + 48;
		Line[5].m_vTo.x = x;
		break;
	case LINE_ABOVE:
		x = lpLine->m_vFrom.x;
		y = lpLine->m_vFrom.y;
		for(i = 0; i < 3; i++)
		{
			Line[i].m_vFrom.x = x;
			Line[i].m_vTo.x = x;
		}
		Line[0].m_vFrom.y = y;
		Line[0].m_vTo.y = y + 48;
		Line[1].m_vFrom.y = y + 48;
		Line[1].m_vTo.y = y + 56;
		Line[2].m_vFrom.y = y + 56;
		Line[2].m_vTo.y = y + 64;
		x = lpLine->m_vTo.x;
		y = lpLine->m_vTo.y;
		for(i = 3; i < 6; i++)
		{
			Line[i].m_vFrom.x = x;
			Line[i].m_vTo.x = x;
		}
		Line[3].m_vFrom.y = y + 64;
		Line[3].m_vTo.y = y + 56;
		Line[4].m_vFrom.y = y + 56;
		Line[4].m_vTo.y = y + 48;
		Line[5].m_vFrom.y = y + 48;
		Line[5].m_vTo.y = y;
		break;
	case LINE_BELOW:
		x = lpLine->m_vFrom.x;
		y = lpLine->m_vFrom.y;
		for(i = 0; i < 3; i++)
		{
			Line[i].m_vFrom.x = x;
			Line[i].m_vTo.x = x;
		}
		Line[0].m_vFrom.y = y;
		Line[0].m_vTo.y = y - 48;
		Line[1].m_vFrom.y = y - 48;
		Line[1].m_vTo.y = y - 56;
		Line[2].m_vFrom.y = y - 56;
		Line[2].m_vTo.y = y - 64;
		x = lpLine->m_vTo.x;
		y = lpLine->m_vTo.y;
		for(i = 3; i < 6; i++)
		{
			Line[i].m_vFrom.x = x;
			Line[i].m_vTo.x = x;
		}
		Line[3].m_vFrom.y = y - 64;
		Line[3].m_vTo.y = y - 56;
		Line[4].m_vFrom.y = y - 56;
		Line[4].m_vTo.y = y - 48;
		Line[5].m_vFrom.y = y - 48;
		Line[5].m_vTo.y = y;
		break;
	}
	CopyMemory(&Line[6].m_vFrom,&Line[2].m_vTo,sizeof(VERTEX));
	CopyMemory(&Line[7].m_vFrom,&Line[1].m_vTo,sizeof(VERTEX));
	CopyMemory(&Line[8].m_vFrom,&Line[0].m_vTo,sizeof(VERTEX));
	CopyMemory(&Line[6].m_vTo,&Line[3].m_vFrom,sizeof(VERTEX));
	CopyMemory(&Line[7].m_vTo,&Line[4].m_vFrom,sizeof(VERTEX));
	CopyMemory(&Line[8].m_vTo,&Line[5].m_vFrom,sizeof(VERTEX));
	for(i = 0; i < 3; i++)
	{
		Line[i].m_Flags = 1;
		Line[i + 3].m_Flags = 1;
		lstrcpy(Line[i].m_sRight.szMiddle,lpszTexture);
		lstrcpy(Line[i + 3].m_sRight.szMiddle,lpszTexture);
	}
	lstrcpy(Line[6].m_sRight.szMiddle,lpszTexture);
	lstrcpy(Line[8].m_sLeft.szLower,lpszTexture);
	Line[6].m_Flags = 1;
	Line[7].m_Flags = 4;
	Line[8].m_Flags = 4;
	iSector[0] = lpMap->GetNewSector();
	iSector[1] = lpMap->GetNewSector();
	iSector[2] = lpMap->GetNewSector();
	lpLine->m_Flags = 4;
	lpLine->m_sLeft.Sector = iSector[0];
	lstrcpy(lpLine->m_sRight.szMiddle,"-");
	lstrcpy(lpLine->m_sLeft.szUpper,"-");
	lstrcpy(lpLine->m_sLeft.szMiddle,"-");
	lstrcpy(lpLine->m_sLeft.szLower,"-");
	Line[0].m_sRight.Sector = iSector[0];
	Line[1].m_sRight.Sector = iSector[1];
	Line[2].m_sRight.Sector = iSector[2];
	Line[3].m_sRight.Sector = iSector[2];
	Line[4].m_sRight.Sector = iSector[1];
	Line[5].m_sRight.Sector = iSector[0];
	Line[6].m_sRight.Sector = iSector[2];
	Line[7].m_sRight.Sector = iSector[1];
	Line[8].m_sRight.Sector = iSector[0];
	Line[7].m_sLeft.Sector = iSector[2];
	Line[8].m_sLeft.Sector = iSector[1];
	for(i = 0; i < 3; i++)
		lpMap->FillSector(&Sector[i]);
	if(iDir == LINE_ABOVE || iDir == LINE_BELOW)
	{
		Sector[0].Light = (m_iLightLevel < 200) ? 200 : m_iLightLevel;
		Sector[1].Light = 255;
		Sector[2].Light = 255;
	}
	else
	{
		Sector[0].Light = (m_iLightLevel > 100) ? 100 : m_iLightLevel;
		Sector[1].Light = (m_iLightLevel > 50) ? 50 : m_iLightLevel;
		Sector[2].Light = (m_iLightLevel > 50) ? 50 : m_iLightLevel;
	}
	Sector[1].Floor = -16;
	Sector[2].Floor = -16;
	Sector[2].Ceiling = -8;
	lstrcpy(Sector[2].szCeiling,"F_SKY1");

	// 07/09/2006 - Added texture offsets
	Line[0].m_sRight.xOffset = 0;
	Line[1].m_sRight.xOffset = 48;
	Line[4].m_sRight.xOffset = 8;
	Line[5].m_sRight.xOffset = 16;

	for(i = 0; i < 9; i++)
	{
		if(i < 3)
			lpMap->AddSector(&Sector[i]);
		lpMap->AddLine(&Line[i]);
	}
}

VOID CPrefabs::CreateOilDrum (CMapConvert* lpMap, INT sParent, INT x, INT y)
{
	CreateCylinder(lpMap,sParent,x,y,"NZOILDRM","FLAT23","SLIME01",32,24);
}

VOID CPrefabs::CreateBarrel (CMapConvert* lpMap, INT sParent, INT x, INT y)
{
	CreateCylinder(lpMap,sParent,x,y,"NZBARREL","FLOOR7_1","FLOOR7_1",30,0);
}

BOOL CPrefabs::ConvertActor (CMapThing* lpThing, USHORT iType)
{
	BOOL bAdd = FALSE;
	INT i = 0;
	while(m_MonsterTable[i].iNum != 0)
	{
		if(m_MonsterTable[i].iNum == iType)
		{
			if(m_MonsterTable[i].iLevel == 3)
				lpThing->m_Options &= ~1;
			else if(m_MonsterTable[i].iLevel == 4)
				lpThing->m_Options &= ~3;
			lpThing->m_Type = m_MonsterTable[i].iDoom;
			lpThing->m_Angle = m_MonsterTable[i].iAngle;
			bAdd = TRUE;
			break;
		}
		i++;
	}
	return bAdd;
}

BOOL CPrefabs::ConvertActorTC (CMapThing* lpThing, USHORT iType)
{
	BOOL bAdd = FALSE;
	INT i = 0;
	while(m_MonsterTableTC[i].iNum != 0)
	{
		if(m_MonsterTableTC[i].iNum == iType)
		{
			if(m_MonsterTableTC[i].iLevel == 3)
				lpThing->m_Options &= ~1;
			else if(m_MonsterTableTC[i].iLevel == 4)
				lpThing->m_Options &= ~3;
			lpThing->m_Type = m_MonsterTableTC[i].iDoom;
			lpThing->m_Angle = m_MonsterTableTC[i].iAngle;
			bAdd = TRUE;
			break;
		}
		i++;
	}
	return bAdd;
}

VOID CPrefabs::CreateSpear (CMapConvert* lpMap, INT sParent, INT x, INT y)
{
	CMapLine Line[4];
	SECTOR Sector;
	INT i, iSector = lpMap->GetNewSector();
	BuildLines(m_vSquare,(FLOAT)1 / (FLOAT)8,Line,4,x,y);
	for(i = 0; i < 4; i++)
	{
		lstrcpy(Line[i].m_sRight.szUpper,"-");
		lstrcpy(Line[i].m_sRight.szMiddle,"NZSPEAR");
		lstrcpy(Line[i].m_sRight.szLower,"-");
		lstrcpy(Line[i].m_sLeft.szUpper,"-");
		lstrcpy(Line[i].m_sLeft.szMiddle,"-");
		lstrcpy(Line[i].m_sLeft.szLower,"-");
		Line[i].m_Flags = 20;
		Line[i].m_Special = 243;	// Only applies to ZDoom
		Line[i].m_Types = 52;		// Only applies to Doom
		Line[i].m_sRight.Sector = sParent;
		Line[i].m_sLeft.Sector = iSector;
		lpMap->AddLine(&Line[i]);
	}
	lpMap->FillSector(&Sector);
	Sector.Light = 255;
	lpMap->AddSector(&Sector);
}

//

VOID CPrefabs::CreateCylinder (CMapConvert* lpMap, INT sParent, INT x, INT y, LPSTR lpszSides, LPSTR lpszTop, LPSTR lpszCenter, INT iSideHeight, INT iCenterHeight)
{
	INT i, iSector;
	CMapLine Line[8];
	SECTOR Sector;

	// Outer
	BuildLines(m_vMiddle,1,Line,8,x,y);
	lstrcpy(Line[0].m_sRight.szUpper,"-");
	lstrcpy(Line[0].m_sRight.szMiddle,"-");
	lstrcpy(Line[0].m_sRight.szLower,lpszSides);
	Line[0].m_sRight.Sector = sParent;
	AlignRightTexture(Line,8,4);
	iSector = lpMap->GetNewSector();
	for(i = 0; i < 8; i++)
	{
		lstrcpy(Line[i].m_sLeft.szUpper,"-");
		lstrcpy(Line[i].m_sLeft.szMiddle,"-");
		lstrcpy(Line[i].m_sLeft.szLower,"-");
		Line[i].m_sLeft.Sector = iSector;
		Line[i].m_Flags = 4;
		lpMap->AddLine(&Line[i]);
	}
	ZeroMemory(&Sector,sizeof(SECTOR));
	Sector.Floor = iSideHeight;
	Sector.Ceiling = (m_bUpperPanels) ? 80 : 64;
	Sector.Light = m_iLightLevel;
	lstrcpy(Sector.szFloor,lpszTop);
	lstrcpy(Sector.szCeiling,m_szCeiling);
	lpMap->AddSector(&Sector);

	// Inner
	for(i = 0; i < 8; i++)
		Line[i].Reset();
	BuildLines(m_vMiddle,1.5,Line,8,x,y);
	lstrcpy(Line[0].m_sRight.szUpper,"-");
	lstrcpy(Line[0].m_sRight.szMiddle,"-");
	lstrcpy(Line[0].m_sRight.szLower,lpszSides);
	Line[0].m_sRight.Sector = iSector;
	AlignRightTexture(Line,8,4);
	iSector = lpMap->GetNewSector();
	for(i = 0; i < 8; i++)
	{
		lstrcpy(Line[i].m_sLeft.szUpper,"-");
		lstrcpy(Line[i].m_sLeft.szMiddle,"-");
		lstrcpy(Line[i].m_sLeft.szLower,"-");
		Line[i].m_Flags = 4;
		lpMap->FlipLinedef(&Line[i],FALSE);
		Line[i].m_sLeft.Sector = Line[i].m_sRight.Sector;
		Line[i].m_sRight.Sector = iSector;
		lpMap->AddLine(&Line[i]);
	}
	ZeroMemory(&Sector,sizeof(SECTOR));
	Sector.Floor = iCenterHeight;
	Sector.Ceiling = (m_bUpperPanels) ? 80 : 64;
	Sector.Light = m_iLightLevel;
	lstrcpy(Sector.szFloor,lpszCenter);
	lstrcpy(Sector.szCeiling,m_szCeiling);
	lpMap->AddSector(&Sector);
}

LONG CPrefabs::LineLength (CMapLine* lpLine)
{
	DOUBLE dx = (DOUBLE)(lpLine->m_vTo.x - lpLine->m_vFrom.x);
	DOUBLE dy = (DOUBLE)(lpLine->m_vTo.y - lpLine->m_vFrom.y);
	return (LONG)sqrt(pow(dx,2) + pow(dy,2));
}

VOID CPrefabs::BuildLines (LPVERTEX lpVertex, FLOAT fScale, CMapLine* lpLines, INT cList, INT x, INT y)
{
	INT i, iEnd = cList - 1;
	for(i = 0; i < cList; i++)
	{
		lpLines[i].m_vFrom.x = (SHORT)((FLOAT)lpVertex[i].x / fScale) + x;
		lpLines[i].m_vFrom.y = (SHORT)((FLOAT)lpVertex[i].y / fScale) + y;
		if(i == iEnd)
		{
			lpLines[i].m_vTo.x = (SHORT)((FLOAT)lpVertex[0].x / fScale) + x;
			lpLines[i].m_vTo.y = (SHORT)((FLOAT)lpVertex[0].y / fScale) + y;
		}
		else
		{
			lpLines[i].m_vTo.x = (SHORT)((FLOAT)lpVertex[i+1].x / fScale) + x;
			lpLines[i].m_vTo.y = (SHORT)((FLOAT)lpVertex[i+1].y / fScale) + y;
		}
	}
}

VOID CPrefabs::AlignRightTexture (CMapLine* lpLines, INT cList, INT cWidth)
{
	INT i, xTexture = 0;
	for(i = 0; i < cList; i++)
	{
		if(i > 0)
		{
			CopyMemory(&lpLines[i].m_sRight,&lpLines[0].m_sRight,sizeof(SIDEDEF));
			lpLines[i].m_sRight.xOffset = xTexture;
		}
		xTexture += LineLength(&lpLines[i]);
		if(xTexture > cWidth)
			xTexture = xTexture % cWidth;
	}
}