#include <windows.h>
#include "resource.h"
#include "..\MapConvert.h"
#include "..\WolfMap.h"
#include "OptionsDlg.h"

COptionsDlg::COptionsDlg (HINSTANCE hInstance, CWolfMap* lpMap) : CQuickDialog(IDD_CONVERTMAP,hInstance)
{
	m_lpMap = lpMap;

	m_iConversionType = CTYPE_INVALID;

	m_szMap[0] = 0;
	m_szLevel[0] = 0;
	m_szOutput[0] = 0;

	m_bFullConversion = FALSE;
	m_bAutoDoors = TRUE;
	m_bFloorZero = FALSE;
}

COptionsDlg::~COptionsDlg ()
{
}

INT COptionsDlg::GetConversionType (VOID)
{
	return m_iConversionType;
}

VOID COptionsDlg::SetConversionType (INT iConversionType)
{
	m_iConversionType = iConversionType;
}

BOOL COptionsDlg::GetFullConversion (VOID)
{
	return m_bFullConversion;
}

VOID COptionsDlg::SetFullConversion (BOOL bFullConversion)
{
	m_bFullConversion = bFullConversion;
}

VOID COptionsDlg::GetMap (LPSTR lpszMap)
{
	lstrcpy(lpszMap,m_szMap);
}

VOID COptionsDlg::GetLevel (LPSTR lpszLevel)
{
	lstrcpy(lpszLevel,m_szLevel);
}

VOID COptionsDlg::GetOutput (LPSTR lpszOutput)
{
	lstrcpy(lpszOutput,m_szOutput);
}

BOOL COptionsDlg::UseAutoDoors (VOID)
{
	return m_bAutoDoors;
}

BOOL COptionsDlg::AllowFloorZero (VOID)
{
	return m_bFloorZero;
}

VOID COptionsDlg::DlgCreate (VOID)
{
	m_hMap = GetDlgItem(IDC_MAP_NAME);
	m_hLevel = GetDlgItem(IDC_WAD_LEVEL);
	m_hFile = GetDlgItem(IDC_WAD_FILE);

	m_hTypeDoom = GetDlgItem(IDC_CTYPE_DOOM);
	m_hTypeZDoom = GetDlgItem(IDC_CTYPE_ZDOOM);

	m_hAutoDoors = GetDlgItem(IDC_AUTO_DOORS);
	m_hFloorZero = GetDlgItem(IDC_FLOOR_ZERO);
	m_hFullConversion = GetDlgItem(IDC_FULL_CONVERSION);

	m_lpMap->EnumMaps(FillMapNames,m_hMap);
	if(m_szMap[0] != 0)
		SendMessage(m_hMap,LB_SELECTSTRING,-1,(LPARAM)m_szMap);

	SetWindowText(m_hLevel,m_szLevel);
	SetWindowText(m_hFile,m_szOutput);

	if(m_iConversionType == CTYPE_DOOM)
		SendMessage(m_hTypeDoom,BM_SETCHECK,TRUE,0);
	else if(m_iConversionType == CTYPE_ZDOOM)
		SendMessage(m_hTypeZDoom,BM_SETCHECK,TRUE,0);

	SendMessage(m_hAutoDoors,BM_SETCHECK,m_bAutoDoors,0);
	SendMessage(m_hFloorZero,BM_SETCHECK,m_bFloorZero,0);
	SendMessage(m_hFullConversion,BM_SETCHECK,m_bFullConversion,0);
}

VOID COptionsDlg::DlgCommand (USHORT id, USHORT iCode)
{
	INT i;
	switch(id)
	{
	case IDOK:
		i = SendMessage(m_hMap,LB_GETCURSEL,0,0);
		if(i >= 0)
		{
			if(SendMessage(m_hAutoDoors,BM_GETCHECK,0,0))
				m_bAutoDoors = TRUE;
			else
				m_bAutoDoors = FALSE;

			if(SendMessage(m_hFloorZero,BM_GETCHECK,0,0))
				m_bFloorZero = TRUE;
			else
				m_bFloorZero = FALSE;

			if(SendMessage(m_hFullConversion,BM_GETCHECK,0,0))
				m_bFullConversion = TRUE;
			else
				m_bFullConversion = FALSE;

			SendMessage(m_hMap,LB_GETTEXT,i,(LPARAM)m_szMap);
			if(GetWindowText(m_hLevel,m_szLevel,16) > 0)
			{
				if(GetWindowText(m_hFile,m_szOutput,256) > 0)
				{
					if(SendMessage(m_hTypeDoom,BM_GETCHECK,0,0))
						m_iConversionType = CTYPE_DOOM;
					else if(SendMessage(m_hTypeZDoom,BM_GETCHECK,0,0))
						if (m_bFullConversion)
							m_iConversionType = CTYPE_ZDOOMTC;
						else
							m_iConversionType = CTYPE_ZDOOM;
					if(m_iConversionType != CTYPE_INVALID)
						End(TRUE);
					else
						MessageBox(GetSelf(),"You must select a conversion format","Conversion Format",MB_OK);
				}
				else
					MessageBox(GetSelf(),"You must enter an output file name","Output",MB_OK);
			}
			else
				MessageBox(GetSelf(),"You must enter a Doom level name such as MAP01","Output Map Level",MB_OK);
		}
		else
			MessageBox(GetSelf(),"You must select a map from the list to convert","Input Map",MB_OK);
		break;
	case IDCANCEL:
		End(FALSE);
		break;
	}
}

BOOL WINAPI COptionsDlg::FillMapNames (LPMAPTYPE lpMap, LPVOID lpParam)
{
	HWND hList = (HWND)lpParam;
	SendMessage(hList,LB_ADDSTRING,0,(LPARAM)lpMap->Name);
	return TRUE;
}