// 04/25/2004 - Finished
// 03/12/2006 - Switched over to inheritance from CQuickApp

#include "..\..\Library\QuickApp.h"
#include "..\WolfMap.h"
#include "..\MapConvert.h"

#define	WM_ADD_DRAW_ITEM			(WM_USER+1)
#define	WM_END_CONVERSION			(WM_USER+2)

typedef struct tagDRAWLIST
{
	INT iType;
	INT x1, y1, x2, y2;
	struct tagDRAWLIST* Next;
} DRAWLIST, *LPDRAWLIST;

class CWinConvApp : public CQuickApp, public CMapConvert
{
protected:
	CWolfMap* m_lpWolfMap;

	HANDLE m_hEvent;
	HANDLE m_hThread;

	CHAR m_szHead[256], m_szData[256];
	CHAR m_szMap[16], m_szLevel[16], m_szOutput[256];

	INT m_xCenter, m_yCenter;
	INT m_xOffset, m_yOffset;
	FLOAT m_fScale;

	HBITMAP m_hbmBuffer;
	HDC m_hdcBuffer;
	HBRUSH m_hbrWhite;
	HPEN m_hpnBlack, m_hpnBlue;

	INT m_iPhase;
	LPDRAWLIST m_lpPhase1, m_lpEnd1;
	LPDRAWLIST m_lpPhase2, m_lpEnd2;

public:
	CWinConvApp (HINSTANCE hInstance, LPSTR lpszCmdLine);
	~CWinConvApp ();

	BOOL IsConverting (VOID);

	// CQuickWin
	virtual BOOL onCreateWindow (HWND hwnd);
	virtual BOOL onFinalize (VOID);
	virtual VOID onDestroy (VOID);
	virtual BOOL onClose (BOOL bTopLevel);
	virtual VOID onActivate (BOOL bActive);
	virtual VOID onGainFocus (HWND hwndLosing);
	virtual VOID onSizeWindow (INT iWidth, INT iHeight);
	virtual VOID onMouseMove (INT iKeys, INT x, INT y);
	virtual VOID onLButtonDown (INT iKeys, INT x, INT y);
	virtual VOID onLButtonUp (INT x, INT y);
	virtual VOID onLButtonDbl (INT x, INT y);
	virtual VOID onRButtonDown (INT iKeys, INT x, INT y);
	virtual VOID onRButtonUp (INT x, INT y);
	virtual VOID onRButtonDbl (INT x, INT y);
	virtual VOID onKeyDown (INT iKey);
	virtual VOID onKeyUp (INT iKey);
	virtual VOID onChar (INT ch);
	virtual LRESULT onCommand (WPARAM wParam, LPARAM lParam);
	virtual VOID onPaint (PAINTSTRUCT* lpps, HDC hdc);
	virtual BOOL onPaintBackground (HDC hdc);
	virtual VOID onDraw (VOID);
	virtual VOID onProcess (VOID);
	virtual VOID onMakeWndClass (WNDCLASS& wc);
	virtual BOOL onBeforeCreateWin (DWORD& dwExStyle, DWORD& dwStyle);
	virtual BOOL onWinMessage (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT& lResult);

protected:
	// CQuickApp
	virtual BOOL onStartApp (HINSTANCE hInstance, LPSTR lpszCmdLine);
	virtual HMENU onLoadMenu (HINSTANCE hInstance);
	virtual BOOL onInitApp (HWND hwnd, BOOL bFullScreen);
	virtual VOID onProcessApp (VOID);
	virtual VOID onExitProgram (VOID);

protected:
	// CConvert
	virtual VOID AddLine (CMapLine* lpLine);
	virtual BOOL TranslateActor (CMapThing* lpThing, USHORT iWolfType);
	virtual BOOL AssignSector (INT x, INT y);
	virtual VOID MergeDone (CMapLine* lpLine);

	VOID ShiftCenter (INT xShift, INT yShift);
	VOID SetCenter (INT x, INT y);
	VOID GetCenter (INT* lpx, INT* lpy);
	VOID SetScale (FLOAT fScale);
	FLOAT GetScale (VOID);

	VOID AddLineItem (CMapLine* lpLine, INT iPhase);
	VOID DrawList (HDC hdc, LPDRAWLIST lpList);
	VOID ClearDrawLists (VOID);

	static BOOL GetWolfFilesFromRegistry (LPSTR lpszHead, LPSTR lpszData);
	static BOOL SetWolfFilesToRegistry (LPSTR lpszHead, LPSTR lpszData);

	static DWORD WINAPI ConversionThread (LPVOID lpParam);
};