// 10/21/2004 - Finished
// 03/12/2006 - Added #ifndef

#ifndef	_H_WOLFMAP
#define	_H_WOLFMAP

typedef	struct
{
	LONG PlaneStart[3];
	USHORT PlaneLength[3];
	USHORT Width, Height;
	CHAR Name[16];
} MAPTYPE, *LPMAPTYPE;

typedef struct
{
	USHORT sEncoding;
	LONG MapStart[100];
} MAPHEAD, *LPMAPHEAD;

typedef struct
{
	USHORT Floor[4096];
	USHORT Object[4096];
} MAPDATA, *LPMAPDATA;

namespace Format
{
	typedef enum
	{
		Bad,
		Normal,
		Raw,
		RawWithHeader
	} Type;
};

typedef BOOL (WINAPI* ENUMWOLFMAPS)(LPMAPTYPE,LPVOID);

class CWolfMap
{
protected:
	MAPHEAD m_Head;
	DWORD m_cData;
	LPBYTE m_lpData;
	BOOL m_bRawMap;

public:
	CWolfMap ();
	~CWolfMap ();

	BOOL IsOpen (VOID);

	BOOL Init (LPSTR lpszHead, LPSTR lpszData);
	USHORT TotalMaps (VOID);
	LONG EnumMaps (ENUMWOLFMAPS lpfnEnum, LPVOID lpParam);

	LPMAPDATA GetMap (LPSTR lpszMap);
	LPMAPDATA GetMap (USHORT iMapNum);
	VOID FreeMap (LPMAPDATA lpMap);

protected:
	BOOL LoadMapHead (LPSTR lpszFile, LPMAPHEAD lpMapHead);
	Format::Type IsRawMap (LPSTR lpszFile, HANDLE hFile);
	LPMAPDATA ExpandMap (LPMAPHEAD lpMapHead, LPMAPTYPE lpType, LPBYTE lpFile);
	VOID RotateData (USHORT* lpData);
	BOOL CompareMapName (LPMAPTYPE lpDesc, LPSTR lpszName);
};

#endif